//*****************************************************************************
//* Copyright (c) 2003-2005 Miday Workshop All rights reserved.
//*
//* File: ColorDef.c
//*****************************************************************************

//general Palm OS includes
#include <PalmOS.h>
#include <TxtGlue.h>
#include <SonyCLIE.h>

//private includes
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//private value
#define X_COL1 4
#define X_COL2 16
#define X_COL3 33
#define X_COL4 45

#define X_COLW 10
#define Y_COLS 25
#define Y_COLD 13
#define Y_COLW 11

static COLOR_DEF Back_color_def[Max_Color_no];
static short Pop_y;
static short Back_max_color, Disp_max_color;

//--------------------------------------------------------
//@J[̋`\
//  The rectangle of a color is displayed.
//--------------------------------------------------------
static void ColorDisp (){
	short ia, ib;
	RectangleType r_col;
	unsigned char codeb, codet;

	r_col.topLeft.y = Y_COLS;
	r_col.extent.x  = X_COLW;
	r_col.extent.y  = Y_COLW;
	if (OS_Color_Support == 1) {//Color?
		for (ia=0; ia<Max_Color_no; ia++ ) {
			for (ib=0;ib<4;ib++ ) {
				switch ( ib ) {
				case 0:
					codeb = Color_def[ia].color1_b;
					codet = Color_def[ia].color1_b;
					r_col.topLeft.x = X_COL1;
					break;
				case 1:
					codeb = Color_def[ia].color1_b;
					codet = Color_def[ia].color1_t;
					r_col.topLeft.x = X_COL2;
					break;
				case 2:
					codeb = Color_def[ia].color2_b;
					codet = Color_def[ia].color2_b;
					r_col.topLeft.x = X_COL3;
					break;
				case 3:
					codeb = Color_def[ia].color2_b;
					codet = Color_def[ia].color2_t;
					r_col.topLeft.x = X_COL4;
					break;
				}

				if ( ia < Color_win_max_color ) {
					WinSetBackColor(codeb);
					WinSetForeColor(codeb);
					WinSetTextColor(codet);
				} else {
					WinSetBackColor(BackColor);
					WinSetForeColor(BackColor);
					WinSetTextColor(BackColor);
				}
				WinFillRectangle(&r_col, 0);
				if ( ia < Color_win_max_color ) {
					WinDrawChars ("8", 1, r_col.topLeft.x+3, r_col.topLeft.y);
				}
				WinSetBackColor(BackColor);
				WinSetForeColor(TextColor);
				WinSetTextColor(TextColor);
			}
			r_col.topLeft.y = r_col.topLeft.y + Y_COLD;
		}
		
	} else {
		for (ia=0;ia<Max_Color_no;ia++ ) {
			if ( ia < Color_win_max_color ) {
				r_col.topLeft.x = X_COL1;
				mono2(r_col.topLeft.x, r_col.topLeft.y, ia+1, 4);
				r_col.topLeft.x = X_COL3;
				mono2(r_col.topLeft.x, r_col.topLeft.y, ia+1, 4);
			} else {
				for ( ib=0; ib<9; ib++ ) {
					WinEraseLine (X_COL1, r_col.topLeft.y+ib, X_COL3+X_COLW, r_col.topLeft.y+ib);
				}
			}
			r_col.topLeft.y = r_col.topLeft.y + Y_COLD;
		}
	}
	if ( Trigger_file_no != 0 ) {
		WinDrawLine (0, 122, 160, 122);
	}
	WinDrawLine (0, 140, 160, 140);
}

//--------------------------------------------------------
//@ݒ
//  Initial setting.
//--------------------------------------------------------
static void ColorDefineInit (){
	short ia, ib;

	MemHandle textH[Max_Color_no];
	char *textP;
	FieldPtr fld;
	short ck_flag;

	lstTable = (ListType *)GetObjectPtr(ColorDefineColorNumberCategoryList);
	LstSetSelection(lstTable, Color_win_max_color-2);
	CtlSetLabel(GetObjectPtr(ColorDefineColorNumberCategoryTrigger),LstGetSelectionText(lstTable, Color_win_max_color-2));

	if ( Opt_g.hol_count_flag == 1 ) {
		ib = Color_win_max_color;
	} else {
		ib = 0;
	}
	for (ia=0;ia<Max_Color_no;ia++ ) {
		if ( ia < Color_win_max_color ) {
			ck_flag = true;
		} else {
			ck_flag = false;
		}

		fld = GetObjectPtr (ColorDefineColor1Text+ia);
		textH[ia] = MemHandleNew (Max_ColorText_no);
		textP = MemHandleLock (textH[ia]);
		if ( ia < Color_win_max_color ) {
			StrCopy(textP, &Color_def[ia].text[0]);
		} else {
			StrCopy(textP, "");
		}
		MemPtrUnlock (textP);

		FldSetTextHandle (fld, textH[ia]);
		FrmShowObject (frm, FrmGetObjectIndex (frm, ColorDefineColor1Text+ia));
		FldSetUsable(GetObjectPtr(ColorDefineColor1Text+ia), ck_flag);

		if ( ia < ib ) {
			CtlSetValue(GetObjectPtr(ColorDefineColor1CheckBox+ia),Color_def[ia].hol_flag);
			CtlShowControl(GetObjectPtr(ColorDefineColor1CheckBox+ia));
		} else {
			CtlSetValue(GetObjectPtr(ColorDefineColor1CheckBox+ia),false);
			CtlHideControl(GetObjectPtr(ColorDefineColor1CheckBox+ia));
		}
		CtlSetEnabled(GetObjectPtr(ColorDefineColor1CheckBox+ia), ck_flag);
	}

	ColorDisp ();
}

//--------------------------------------------------------
//@f[^荞
//  "Explanation data" got.
//--------------------------------------------------------
static void ColorTextGet (){
	short ia, ix, iz;
	char  *textP;
	MemHandle textH;
	FieldPtr fld;
	unsigned long st_byte, en_byte, xintlMgrExists;

	for (ia=0;ia<Color_win_max_color;ia++ ) {
		fld = GetObjectPtr (ColorDefineColor1Text+ia);
		textH = FldGetTextHandle (fld);
		textP = MemHandleLock (textH);
		if ( StrLen(textP) >= Max_ColorText_no ) {

			if ( FtrGet(sysFtrCreator, sysFtrNumIntlMgr, &xintlMgrExists) != 0 ) xintlMgrExists = 0;
			if ( xintlMgrExists ) {
				TxtCharBounds(textP, Max_ColorText_no-2, &st_byte, &en_byte);
				if ( en_byte == Max_ColorText_no-1 ) {
					StrNCopy(&Color_def[ia].text[0], textP, Max_ColorText_no-1);
					Color_def[ia].text[Max_ColorText_no-1] = '\0';
				} else {
					StrNCopy(&Color_def[ia].text[0], textP, Max_ColorText_no-2);
					Color_def[ia].text[Max_ColorText_no-2] = '\0';
				}
			} else {
				for ( iz=0; iz<StrLen(textP); iz++ ) {//Japanese(shift JIS) or English only
					if ((textP[iz+1]>=0x81 && textP[iz+1]<=0x9f) ||
					    (textP[iz+1]>=0xe0 && textP[iz+1]<=0xfc)) {
						if ( iz+1 >= Max_ColorText_no-1 ) {
							ix = iz;
							break;
						}
						iz++;
					}
					if ( iz >= Max_ColorText_no-1 ) {
						ix = iz;
						break;
					}
				}
				StrNCopy(&Color_def[ia].text[0], textP, ix);
				Color_def[ia].text[ix] = '\0';
			}

		} else {
			StrCopy(&Color_def[ia].text[0], textP);
		}
		MemPtrUnlock (textP);
	}
}

//--------------------------------------------------------
//@CxgnhO
//  Event handling.
//--------------------------------------------------------
Boolean ColorDefineHandleEvent (EventPtr event){
	RectangleType r_col;
	Boolean handled = false;
	short ia, iz, x_flag;
	char filename[33];

	IndexedColorType drawIndex = 0;
	RGBColorType rgb = {0,0,0,0};  // =black

	frm = FrmGetFormPtr (ColorDefine);

	if (event->eType == penDownEvent) {
		Pop_y = (event->screenY + 10 ) / 11 - 1;
		if(Pop_y < 0 || Pop_y > 7 ) Pop_y = 888;
		if(event->screenX < 0 || event->screenX > 50 ) Pop_y = 888;
	} else if (event->eType == penUpEvent) {
		if (OS_Color_Support == 1) {//Color?
			if((event->screenX > X_COL1 && event->screenX <= X_COL1+X_COLW ) || (event->screenX > X_COL2 && event->screenX <= X_COL2+X_COLW ) ||
			   (event->screenX > X_COL3 && event->screenX <= X_COL3+X_COLW ) || (event->screenX > X_COL4 && event->screenX <= X_COL4+X_COLW) ) {
				for (ia=0;ia<Color_win_max_color;ia++) {
					if(event->screenY > Y_COLS+ia*Y_COLD && event->screenY <= Y_COLS+ia*Y_COLD+Y_COLW ) {
						if(event->screenX > X_COL1 && event->screenX <= X_COL1+X_COLW ) {
							x_flag = 1;
						} else if (event->screenX > X_COL2 && event->screenX <= X_COL2+X_COLW ) {
							x_flag = 2;
						} else if (event->screenX > X_COL3 && event->screenX <= X_COL3+X_COLW ) {
							x_flag = 3;
						} else if (event->screenX > X_COL4 && event->screenX <= X_COL4+X_COLW ) {
							x_flag = 4;
						}
						switch ( x_flag ) {
						case 1:
							drawIndex = Color_def[ia].color1_b;
							rgb       = Color_def[ia].rgbcolor1_b;
							break;
						case 2:
							drawIndex = Color_def[ia].color1_t;
							rgb       = Color_def[ia].rgbcolor1_t;
							break;
						case 3:
							drawIndex = Color_def[ia].color2_b;
							rgb       = Color_def[ia].rgbcolor2_b;
							break;
						case 4:
							drawIndex = Color_def[ia].color2_t;
							rgb       = Color_def[ia].rgbcolor2_t;
							break;
						}
						WinIndexToRGB(drawIndex,&rgb);
						if (UIPickColor(&drawIndex, &rgb, UIPickColorStartPalette, NULL, NULL)) {
							switch ( x_flag ) {
							case 1:
								Color_def[ia].color1_b    = drawIndex;
								Color_def[ia].rgbcolor1_b = rgb;
								break;
							case 2:
								Color_def[ia].color1_t    = drawIndex;
								Color_def[ia].rgbcolor1_t = rgb;
								break;
							case 3:
								Color_def[ia].color2_b    = drawIndex;
								Color_def[ia].rgbcolor2_b = rgb;
								break;
							case 4:
								Color_def[ia].color2_t    = drawIndex;
								Color_def[ia].rgbcolor2_t = rgb;
								break;
							}
							r_col.topLeft.y = Y_COLS+ia*Y_COLD;
							r_col.extent.x  = X_COLW;
							r_col.extent.y  = Y_COLW;
							if ( x_flag <= 2 ) {
								r_col.topLeft.x = X_COL1;
								WinSetBackColor(Color_def[ia].color1_b);
								WinSetForeColor(Color_def[ia].color1_b);
								WinSetTextColor(Color_def[ia].color1_t);
							} else {
								r_col.topLeft.x = X_COL3;
								WinSetBackColor(Color_def[ia].color2_b);
								WinSetForeColor(Color_def[ia].color2_b);
								WinSetTextColor(Color_def[ia].color2_t);
							}
							WinFillRectangle(&r_col, 0);

							r_col.topLeft.x = r_col.topLeft.x + X_COL2 - X_COL1;
							WinFillRectangle(&r_col, 0);
							WinDrawChars ("8", 2, r_col.topLeft.x+3, r_col.topLeft.y);
							WinSetBackColor(BackColor);
							WinSetForeColor(TextColor);
							WinSetTextColor(TextColor);
						}
						FrmDrawForm(frm);
						ColorDisp ();
						if ( Opt_g.hol_count_flag == 1 ) {
							WinDrawChars(HolDefString, StrLen(HolDefString), 78, 12);
						}
						break;
					}
				}
				handled = true;
			}
		}

	} else if (event->eType == popSelectEvent){
		switch (event->data.ctlSelect.controlID){
		case ColorDefineColorNumberCategoryTrigger:
			ColorTextGet ();
			lstTable            = (ListType *)GetObjectPtr(ColorDefineColorNumberCategoryList);
			Color_win_max_color = LstGetSelection(lstTable) + 2;
			if ( Color_win_max_color > Disp_max_color ) {
				Md_InitRedDate(Disp_max_color+1);
				Disp_max_color = Color_win_max_color;
			}
			ColorDefineInit();
			break;
		}

	} if (event->eType == ctlSelectEvent) {
		switch (event->data.ctlSelect.controlID) {
		case ColorDefineOKButton:
			if ( Color_win_max_color < Back_max_color ) {
				if ( RsetRedDataOfArray(Color_win_max_color+1, Back_max_color) == 2 ) {
					break;
				}

				if ( Color_no > Color_win_max_color ) Color_no = 1;
				for ( iz=0; iz<WEEK_DAYS_NO; iz++ ) {//SUN-SAT
					if ( Opt_g.week_color[iz] > Color_win_max_color ) {
						if ( iz == 0 || iz == 6 ) {
							Opt_g.week_color[iz] = 1;
						} else {
							Opt_g.week_color[iz] = 0;
						}
					}
				}
				for ( iz=0; iz<MAX_MEMORIAL_DEFNO; iz++ ) {
					if ( Opt_g.memorial_col1[iz] > Color_win_max_color ) Opt_g.memorial_col1[iz] = 0;
					if ( Opt_g.memorial_col2[iz] > Color_win_max_color ) Opt_g.memorial_col2[iz] = 0;
				}
			}

			//xON OFF؂ւ̃`FbN    (Holiday checkbox change?)
			if ( Opt_g.hol_count_flag == 1 ) {
				for ( iz=0; iz<MAX_MEMORIAL_DEFNO; iz++ ) {
					if ( Back_color_def[Opt_g.memorial_col1[iz]].hol_flag != Color_def[Opt_g.memorial_col1[iz]].hol_flag ) Opt_g.memorial_col1[iz] = 0;
					if ( Back_color_def[Opt_g.memorial_col2[iz]].hol_flag != Color_def[Opt_g.memorial_col2[iz]].hol_flag ) Opt_g.memorial_col2[iz] = 0;
				}
			}

			Dataupdateflag = 1;
			for (ia=0;ia<Max_Color_no;ia++) {
				Color_def[ia].hol_flag = CtlGetValue(GetObjectPtr(ColorDefineColor1CheckBox+ia));
			}
			ColorTextGet ();
			switch (Color_call_win) {
			case 1:
				FrmGotoForm (MainWin);
				break;
			case 2:
				Back_md_flag = 1;
				FrmGotoForm (Model);
				break;
			case 3:
				Back_me_flag = 1;
				FrmGotoForm (MemorialWin);
				break;
			}
			handled = true;
			break;
		case ColorDefineCancelButton:
			MemMove(&Color_def[0].hol_flag, &Back_color_def[0].hol_flag, sizeof(COLOR_DEF)*Max_Color_no);
			Color_win_max_color = Back_max_color;
			switch (Color_call_win) {
			case 1:
				FrmGotoForm (MainWin);
				break;
			case 2:
				Back_md_flag = 1;
				FrmGotoForm (Model);
				break;
			case 3:
				Back_me_flag = 1;
				FrmGotoForm (MemorialWin);
				break;
			}
			handled = true;
			break;
		case ColorDefineInportButton:
			if ( StrCompare (CtlGetLabel(GetObjectPtr(ColorDefineInportCategoryTrigger)),trigger_file_title) != 0 ) {
				if ( FrmAlert(AltColorFileInport) == 0 ) {
					StrCopy(filename, Col_FileName);
					StrCat (filename, CtlGetLabel(GetObjectPtr(ColorDefineInportCategoryTrigger)));
					StrCat (filename, Col_FileSuffix);
					Md_GetDatabase(2, filename);
				}
			}
			CtlSetLabel(GetObjectPtr(ColorDefineInportCategoryTrigger), trigger_file_title);
//			ColorDisp ();
			ColorDefineInit();
			break;
		}
	}

	else if (event->eType == menuEvent){
		switch (event->data.menu.itemID){
		case AboutAboutCmd:
			FrmPopupForm(AboutDialog);
			break;
		}
	}

	else if (event->eType == frmOpenEvent){
		MemMove(&Back_color_def[0].hol_flag, &Color_def[0].hol_flag, sizeof(COLOR_DEF)*Max_Color_no);
		Back_max_color = Color_win_max_color;
		Disp_max_color = Color_win_max_color;

		StrCopy (trigger_file_title, CtlGetLabel(GetObjectPtr(ColorDefineInportCategoryTrigger)));
		SetColorFileCategory(ColorDefineInportCategoryList, ColorDefineInportCategoryTrigger, ColorDefineInportButton);
		FrmDrawForm(frm);
		if ( Opt_g.hol_count_flag == 1 ) {
			WinDrawChars(HolDefString, StrLen(HolDefString), 78, 12);
		}
		ColorDefineInit();
		handled = true;

	}else if (event->eType == frmUpdateEvent){
		handled = true;
	}

	return (handled);
}
