//*****************************************************************************
//* Copyright (c) 2001-2005 Miday Workshop All rights reserved.
//*   (Calculation processing of "Vernal Equinox Day"/"Autumnal Equinox Day" is not included.)
//*
//* File: get_hol_J.c
//*****************************************************************************

extern short GetDayOfTheWeek(short year, short month, short *day_no);
extern void GetHoliday( short year, short month, short *hol_no, short hol_day[] );
extern void EasterGet(short year, short *month, short *day );

//Version 3.3 Add Start
void EasterGet(short year, short *month, short *day ) {
	*month = 0;
	*day   = 0;
}
//Version 3.3 Add End

//holiday
//  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31
//start_day == ?
//  0  6  5  4  3  2  1  0  6  5  4  3  2  1  0  6  5  4  3  2  1  0  6  5  4  3  2  1  0  6  5

//--------------------------------------------------------
//@Nw肵čՓo
//  The national holiday of the month is calculated.
//--------------------------------------------------------
void GetHoliday( short year, short month, short *hol_no, short hol_day[] ) {
//year           N        (Year)    2000 or later
//month                  (Month)
//hol_no         Փ̐  (The number of national holidays)
//hol_day        Փ      (national holidays)
	short start_day, ia, dum;

	*hol_no = 0;
	start_day = GetDayOfTheWeek(year, month, &dum);
	switch (month) {
	case 1:
		*hol_no = 2;
		ia = 0;
		hol_day[ia] = 1;     	//U
		if ( start_day == 0 ) hol_day[ia] = 2;

		ia = 1;
		if ( year < 2000 ) {
			hol_day[ia] = 15;	//l̓
			if ( start_day == 0 ) hol_day[ia] = 16;
		} else {
			if (start_day < 2) {	//l̓
				hol_day[ia] = 9 - start_day;
			} else {
				hol_day[ia] = 16 - start_day;
			}
		}
		break;
	case 2:
		*hol_no = 1;
		ia = 0;
		hol_day[ia] = 11;	//LO
		if ( start_day == 4 ) hol_day[0] = 12;
		if ( year > 2019 ) {
			*hol_no = 2;
			ia = 1;
			hol_day[ia] = 23;	//Vca
			if ( start_day == 6 ) hol_day[ia] = 24;
		}
		break;
	case 3:
		if ( year >= 1900 && year <= 2099 ) {  //version 3.3 add
			*hol_no = 1;
			ia = 0;
			if ( year < 1980 ) {	//t̓iCۈH@vZҁ@Vݕ֗@j
				hol_day[ia] = 20.8357 + 0.242194 * (year-1980)- (year-1983) / 4;
			} else {
				hol_day[ia] = 20.8431 + 0.242194 * (year-1980)- (year-1980) / 4;
			}
			if ( hol_day[ia] <= 21 ) {
				if ( start_day == (22 - hol_day[ia]) ) hol_day[ia]++;
			} else {
				if ( start_day == (29 - hol_day[ia]) ) hol_day[ia]++;
			}
		}  //version 3.3 add
		break;
	case 4:
		*hol_no = 0;
		ia = 0;
		if ( year != 2019 ) {
			*hol_no = 1;
			hol_day[ia] = 29;	//a̓i݂ǂ̓j
			if ( start_day == 0 ) hol_day[ia] = 30;
		} else {
			*hol_no = 2;
			hol_day[0] = 29;	//a̓i݂ǂ̓j
			hol_day[1] = 30;	//̋x
		}
		break;
	case 5:
		if ( year != 2019 ) {
			*hol_no = 3;
			if ( year < 2007 ) {
				hol_day[0] = 3;		//@LO
				hol_day[1] = 4;		//̋x
				hol_day[2] = 5;		//q̓
				if ( start_day == 3 ) hol_day[2] = 6;
			} else {
				switch(start_day) {
				case 3:
					hol_day[0] = 3;		//@LO
					hol_day[1] = 4;		//݂ǂ̓
					hol_day[2] = 6;
					break;
				case 4:
					hol_day[0] = 3;		//@LO
					hol_day[1] = 5;		//q̓
					hol_day[2] = 6;
					break;
				case 5:
					hol_day[0] = 4;		//݂ǂ̓
					hol_day[1] = 5;		//q̓
					hol_day[2] = 6;
					break;
				default:
					hol_day[0] = 3;		//@LO
					hol_day[1] = 4;		//݂ǂ̓
					hol_day[2] = 5;		//q̓
					break;
				}
			}
		} else {
			*hol_no = 6;
			hol_day[0] = 1;		//ʂɔj
			hol_day[1] = 2;		//̋x
			hol_day[2] = 3;		//@LO
			hol_day[3] = 4;		//̋x
			hol_day[4] = 5;		//q̓
			hol_day[5] = 6;		//Uւ
		}
		break;
	case 7:
		*hol_no = 0;
		ia = 0;
		if ( year >= 1996 ) {
			if ( year != 2020 && year != 2021 ) {
				*hol_no = 1;
				if ( year < 2003 ) {
					hol_day[ia] = 20;	//C̓@1996N
					if ( start_day == 2 ) hol_day[ia] = 21;
				} else {
					if (start_day < 2) {	//C̓
						hol_day[ia] = 16 - start_day;
					} else {
						hol_day[ia] = 23 - start_day;
					}
				}
			} else if ( year == 2020 ) {
				*hol_no = 2;
				hol_day[0] = 23;	//IsbN̓
				hol_day[1] = 24;	//IsbN̓
			} else {//year == 2021
				*hol_no = 2;
				hol_day[0] = 22;	//IsbN̓
				hol_day[1] = 23;	//IsbN̓
			}
		}
		break;
	case 8:
		*hol_no = 0;
		ia = 0;
		if ( year != 2020 && year != 2021 ) {
			if ( year >= 2016 ) {
				*hol_no = 1;
				hol_day[ia] = 11;	//R̓
				if ( start_day == 4 ) hol_day[ia] = 12;
			}
		} else if ( year == 2020 ) {
			*hol_no = 1;
			hol_day[0] = 10;	//IsbN̓
		} else {//year == 2021
			*hol_no = 1;
			hol_day[0] = 9;	//IsbN̓ {́A8/8(j)IsbN̓8/9͐Uւx
		}
		break;
	case 9:
		*hol_no = 2;
		ia = 0;
		if ( year < 2003 ) {
			hol_day[ia] = 15;	//hV̓
			if ( start_day == 0 ) hol_day[ia] = 16;
		} else {
			if (start_day < 2) {	//hV̓
				hol_day[ia] = 16 - start_day;
			} else {
				hol_day[ia] = 23 - start_day;
			}
		}

		if ( year >= 1900 && year <= 2099 ) {  //version 3.3 add
			ia = 1;
			if ( year < 1980 ) {	//H̓iCۈH@vZҁ@Vݕ֗@j
				hol_day[ia] = 23.2588 + 0.242194 * (year-1980)- (year-1983) / 4;
			} else {
				hol_day[ia] = 23.2488 + 0.242194 * (year-1980)- (year-1980) / 4;
			}
			if ( hol_day[ia] <= 21 ) {
				if ( start_day == (22 - hol_day[ia]) ) hol_day[ia]++;
			} else {
				if ( start_day == (29 - hol_day[ia]) ) hol_day[ia]++;
			}

			if ( hol_day[1] - hol_day[0] == 2 ) {  	//̋x
				*hol_no   = 3;
				hol_day[2] = hol_day[1];
				hol_day[1] = hol_day[0] + 1;
			}
//Version 3.3 Add Start
		} else {
			*hol_no = 1;
		}
//Version 3.3 Add End
		break;
	case 10:
		*hol_no = 0;
		ia = 0;
		if ( year != 2020 && year != 2021 ) {
			if ( year != 2019 ) {
				*hol_no = 1;
				if ( year < 2000 ) {
					hol_day[ia] = 10;	//̈̓
					if ( start_day == 5 ) hol_day[ia] = 11;
				} else {
					if (start_day < 2) {	//̈̓
						hol_day[ia] = 9 - start_day;
					} else {
						hol_day[ia] = 16 - start_day;
					}
				}
			} else {
				*hol_no = 1;
				hol_day[ia] = 22;	//ʗ琳a̋V
			}
		}
		break;
	case 11:
		*hol_no = 2;
		ia = 0;
		hol_day[ia] = 3;	//̓
		if ( start_day == 5 ) hol_day[ia] = 4;

		ia = 1;
		hol_day[ia] = 23;	//ΘJӂ̓
		if ( start_day == 6 ) hol_day[ia] = 24;
		break;
	case 12:
		*hol_no = 0;
		ia = 0;
		if ( year < 2019 ) {//2020Nȍ~͕s
			*hol_no = 1;
			hol_day[ia] = 23;	//Vca
			if ( start_day == 6 ) hol_day[ia] = 24;
		}
		break;
	default:
		*hol_no = 0;
		break;
	}
}
